import json
from tool import *
from db_connet import *
import re

mydict = create_dict()

# firm_servece data
sql = "SELECT id,name FROM `firm_services` where deleted_at is null"
result = select_db(sql,'member')
firm_service_name = {}
for val in result:
    if val['id'] > 7 and val['id'] != 25 :
        firm_service_name[val['id']] = '快閃'
    else:
        firm_service_name[val['id']] = val['name']

def ck_gender(data):
    if data is None:
        return ''

    if data == 1:
        return 'male'

    if data == 0:
        return 'female'

# ===== 會員中心 to Omni ====
sql = "SELECT( CASE WHEN u.source_firm_service_id = 1 THEN l.user_id "
sql += "WHEN u.source_firm_service_id = 2 THEN CONCAT('m',l.user_id) "
sql += "WHEN u.source_firm_service_id not in (1,2,3,4,7) THEN CONCAT('p',u.id) END ) as uid,"
sql += "u.mobile, u.email 'email', u.source_firm_service_id, u.line_code, p.name, p.gender, p.birthday, "
sql += "p.county, p.district, DATE_FORMAT(u.created_at, '%Y-%m-%d') created_at "
sql += "FROM `user_relations` r "
sql += "LEFT JOIN `users` u on r.user_id = u.id "
sql += "LEFT JOIN `user_profiles` p on u.id = p.user_id "
sql += "LEFT JOIN `user_services` s on s.user_relation_id = r.id "
sql += "LEFT JOIN link_users l on l.user_service_id = s.id  "
sql += "LEFT JOIN firm_services fs on fs.id = s.firm_service_id "
sql += "where u.mobile = '0912875573' and "
sql += "u.source_firm_service_id = s.firm_service_id and "
sql += "u.deleted_at is null"

print(sql)
exit()

# ===== 更新線下會員資料 ====
#sql = "SELECT concat('p',u.id) 'member_sn', u.mobile, u.email 'email', u.source_firm_service_id, u.line_code, p.name, p.gender, p.birthday, p.county, p.district, DATE_FORMAT(u.created_at, '%Y-%m-%d') created_at FROM `user_relations` r LEFT JOIN `users` u on r.user_id = u.id LEFT JOIN `user_profiles` p on u.id = p.user_id "
sql = "SELECT count(1) FROM `user_relations` r LEFT JOIN `users` u on r.user_id = u.id LEFT JOIN `user_profiles` p on u.id = p.user_id LEFT JOIN `user_services` s on s.user_relation_id = r.id LEFT JOIN link_users l on l.user_service_id = s.id "
sql += "where u.deleted_at is null and u.source_firm_service_id not in ('1','2','3','4','7') "
# sql += "u.mobile = '0961300638' "
# sql += "order by u.id DESC "
# sql += f"u.updated_at like '{today()}%' "
# sql += "limit 10"
print(sql)
exit()
result = select_db(sql,'member')
for row in result:
    

    mydict.add(row['member_sn'],
        ({
            "member_sn":row['member_sn'],
            "name": '' if row['name'] is None else row['name'],
            "email": '' if row['email'] is None else row['email'],
            "phone" :pattern_886(row['mobile']),
            "sex": ck_gender(row['gender']),
            "register_date": row['created_at'],
            "city": '' if row['county'] is None else row['county'],
            "country":'Taiwan',
            "iso_code":'TW',
            "register_type": firm_service_name[row['source_firm_service_id']],
            "line_id": '' if row['line_code'] is None else row['line_code'],
        })
    )


print(format_json(mydict))
exit()

# 更新線上會員資料(彌月)
sql = "SELECT concat('m',l.user_id) 'member_sn', u.mobile, u.email 'email', u.source_firm_service_id, u.line_code, p.name, p.gender, p.birthday, p.county, p.district, DATE_FORMAT(u.created_at, '%Y-%m-%d') created_at FROM `user_relations` r LEFT JOIN `users` u on r.user_id = u.id LEFT JOIN `user_profiles` p on u.id = p.user_id LEFT JOIN `user_services` s on s.user_relation_id = r.id LEFT JOIN link_users l on l.user_service_id = s.id "
sql += "where u.source_firm_service_id = s.firm_service_id and u.deleted_at is null and l.user_id is not null "
sql += "and u.source_firm_service_id = '2' "
sql += "limit 1000 "
i = to_sql(sql,'member')

for row in i:
    mydict.add(row['member_sn'],
        ({
            "member_sn":row['member_sn'],
            "name":row['name'],
            "email":row['email'],
            "phone" :pattern_886(row['mobile']),
            "sex": 'male' if row['gender'] == 1 else 'female',
            "register_date": row['created_at'],
            "city": row['county'],
            "country":'Taiwan',
            "iso_code":'TW',
            "register_type": firm_service_name[row['source_firm_service_id']],
            "line_id": row['line_code'],
        })
    )


print(format_json(mydict))
# for val in mydict:
#     print(omni_api(mydict[val]))

exit()


# 更新線上會員資料(官網)
sql = "SELECT l.user_id 'member_sn', u.mobile, u.email 'email', u.source_firm_service_id, u.line_code, p.name, p.gender, p.birthday, p.county, p.district, DATE_FORMAT(u.created_at, '%Y-%m-%d') created_at FROM `user_relations` r LEFT JOIN `users` u on r.user_id = u.id LEFT JOIN `user_profiles` p on u.id = p.user_id LEFT JOIN `user_services` s on s.user_relation_id = r.id LEFT JOIN link_users l on l.user_service_id = s.id "
sql += "where u.source_firm_service_id = s.firm_service_id and u.deleted_at is null and l.user_id is not null "
# sql += "and u.mobile = '0982938209' "
sql += "and u.source_firm_service_id = '1' "
sql += "limit 1000 "
i = to_sql(sql,'member')

for row in i:
    mydict.add(row['member_sn'],
        ({
            "member_sn":row['member_sn'],
            "name":row['name'],
            "email":row['email'],
            "phone" :pattern_886(row['mobile']),
            "sex": 'male' if row['gender'] == 1 else 'female',
            "register_date": row['created_at'],
            "city": row['county'],
            "country":'Taiwan',
            "iso_code":'TW',
            "register_type": firm_service_name[row['source_firm_service_id']],
            "line_id": row['line_code'],
        })
    )

exit()
